=== modified file 'olive.glade'
--- olive.glade	2007-11-28 18:00:03 +0000
+++ olive.glade	2008-03-04 14:14:42 +0000
@@ -58,6 +58,14 @@
                       </widget>
                     </child>
                     <child>
+                      <widget class="GtkMenuItem" id="menuitem_file_bookmark">
+                        <property name="visible">True</property>
+                        <property name="label" translatable="yes">_Bookmark current directory</property>
+                        <property name="use_underline">True</property>
+                        <signal name="activate" handler="on_menuitem_file_bookmark_activate"/>
+                      </widget>
+                    </child>
+                    <child>
                       <widget class="GtkMenuItem" id="menuitem_file_make_directory">
                         <property name="visible">True</property>
                         <property name="label" translatable="yes">Make _directory...</property>

=== modified file 'olive/__init__.py'
--- olive/__init__.py	2008-03-04 14:18:03 +0000
+++ olive/__init__.py	2008-03-30 14:11:42 +0000
@@ -106,6 +106,7 @@
         # Get some important menu items
         self.menuitem_add_files = self.toplevel.get_widget('menuitem_add_files')
         self.menuitem_remove_files = self.toplevel.get_widget('menuitem_remove_file')
+        self.menuitem_file_bookmark = self.toplevel.get_widget('menuitem_file_bookmark')
         self.menuitem_file_make_directory = self.toplevel.get_widget('menuitem_file_make_directory')
         self.menuitem_file_rename = self.toplevel.get_widget('menuitem_file_rename')
         self.menuitem_file_move = self.toplevel.get_widget('menuitem_file_move')
@@ -162,6 +163,7 @@
                 "on_about_activate": self.on_about_activate,
                 "on_menuitem_add_files_activate": self.on_menuitem_add_files_activate,
                 "on_menuitem_remove_file_activate": self.on_menuitem_remove_file_activate,
+                "on_menuitem_file_bookmark_activate": self.on_menuitem_file_bookmark_activate,
                 "on_menuitem_file_make_directory_activate": self.on_menuitem_file_make_directory_activate,
                 "on_menuitem_file_move_activate": self.on_menuitem_file_move_activate,
                 "on_menuitem_file_rename_activate": self.on_menuitem_file_rename_activate,
@@ -699,6 +701,18 @@
         finally:
             branch.unlock()
     
+    def on_menuitem_file_bookmark_activate(self, widget):
+        """ File/Bookmark current directory menu handler. """
+        if self.pref.add_bookmark(self.path):
+            info_dialog(_('Bookmark successfully added'),
+                        _('The current directory was bookmarked. You can reach\nit by selecting it from the left panel.'))
+            self.pref.write()
+        else:
+            warning_dialog(_('Location already bookmarked'),
+                           _('The current directory is already bookmarked.\nSee the left panel for reference.'))
+        
+        self.refresh_left()
+    
     def on_menuitem_file_make_directory_activate(self, widget):
         """ File/Make directory... menu handler. """
         from mkdir import OliveMkdir

